package mm;
import java.util.Random;
import java.util.ArrayList;


public class mm_p {

  public static void main (String[] args) {
    Random rnd = new Random();
     //ArrayList<passenger> PassengerArray = new ArrayList<Passenger>();  
     //order cue シミュレートに出現する客の順番が書かれた、予言の書的なもの
     //あるいは、毎回の区切り毎に判定するか？
     //この仕様では時間軸でのフレームが存在しないので。一括作成=>一括処理がよかろう。
     //sampleもこの方式        System.out.println(sim_time+" "+waiting_passenger );

  
   /*まず、客がどのように出没するかを作成。*/
    double time = 0;
    int pnum = 8+rnd.nextInt(4);
    Passenger[] Passengers = new Passenger[pnum];
     
   //pnum...passenger num. 想定されるお客の数
   //平均して10人程度お客が来るという設定
   
     //とりあえずでーたをつくる
    for (int i=0;i<pnum;i++){     
      Passengers[i] = new Passenger();
      Passengers[i].setTasktime( (rnd.nextDouble()+1.0));      
      time+=rnd.nextDouble()*2.6;
      Passengers[i].setArrivetime(time);       
    }
    
    for(int i=0;i<pnum;i++){
        System.out.print("#Passengers no."+ i );
        System.out.print("# Arrive: "+ Passengers[i].getArrivetime());
        System.out.println("# Task: "+ Passengers[i].getTasktime());
    }    
 
    //mm1をまわす部分     
    double sim_time = 0;
    double waiting_time = 0;
    double working_time = 0;
    double next_releasetime=0;
    double next_arrivetime=0;
    double next_steptime=0;
    double free_time=0;
    int next_flag=0;// 0=次はきゃくがデル 1=つぎは客入り 2 暇 
    int waiting_passenger;
    //watingtime=ステップ長*wating_passenger.
    //ステップ長は、min(next_arrivetime[j] or next releasetime[i]) - sim_time
    //となる        
    //load 最初のお客さんが入ったとき
    sim_time=Passengers[0].getArrivetime();
    waiting_passenger=0;
    next_releasetime = sim_time+Passengers[0].getTasktime();
    next_arrivetime = Passengers[1].getArrivetime();
    System.out.println("#p0 in"+sim_time);
    System.out.println("#p0 workin");
    System.out.println(sim_time+" "+waiting_passenger );       

     
    int live=0;//現在処理中のタスク
    int in=1;//次回待ち行列に投入されるタスク   
/*    
1.次のイベントが、(客が入る)と(客がぬける)のどちらかを確認する。

2. シミュレータ上の現在時刻から、次回イベントの予定時刻までの間、列に並んだ客の分だけ待ち時間を計算する。

3.(客が入る)と(客がぬける)のどちらかが起こり、列に並んだ客の数が更新される。次回のイベントの時間も更新される。

  これらを繰り返すと、いつかデータ上の最後の客が来店する。
  こうなると(客が抜ける)以外のイベントは発生しない。そうなると。

4.場合分けを考慮しない計算方法に移行する。
この計算はすぐに終わる。
*/


    
    while(live<pnum-1){
 
      //次のイベントが"ぬける" (1.の処理)
      if(next_releasetime < next_arrivetime){
        next_flag=0;
        next_steptime=next_releasetime;
      }     
      
      //次のイベントが"入る"(1.の処理)
      if(next_releasetime > next_arrivetime){
        next_flag=1;
        next_steptime=Passengers[in].getArrivetime();
      }
           
      //次のイベントがくるまで仕事をする。この時、客の待ち時間が決定(2.の処理)
      if(waiting_passenger>0){
        waiting_time+=waiting_passenger*(next_steptime - sim_time);
      }
      sim_time=next_steptime;
        
        //次のイベントが"入る"なので新しく客が入る(3.の処理)
        if(next_flag==1){
          System.out.println(sim_time+" "+waiting_passenger );
          waiting_passenger++;
          System.out.println(sim_time+" "+waiting_passenger );
          if (in==pnum-1){
            System.out.println("#all passengers came");//(4.に分岐)
              break;
          }
        System.out.println("#p"+in+" in "+sim_time+" "+waiting_passenger);
        
        in++;
        next_arrivetime = Passengers[in].getArrivetime();
        //System.out.println(" next_arrivetime:"+next_arrivetime +",p"+in);
        //System.out.println(" next_releasetime:"+next_releasetime+",p"+live);
      }
            
      if(next_flag==0){
        //次のイベントが"ぬける"なので客がいなくなる(3.の処理)
        System.out.println(sim_time+" "+waiting_passenger );
        waiting_passenger--;
        System.out.println(sim_time+" "+waiting_passenger );
        System.out.println("#p"+ live +" out "+sim_time+" "+waiting_passenger); 
        live++;     
         
        if(waiting_passenger<0){
          //次の客がいないので、来るまで待つ
          free_time += Passengers[in].getArrivetime() - sim_time;
          sim_time=Passengers[in].getArrivetime();
          next_arrivetime = Passengers[in].getArrivetime();
          next_releasetime = sim_time + Passengers[in].getTasktime();
          System.out.println("#free now, wait for p"+ in ); 
          //System.out.print(" next_arrivetime:"+next_arrivetime+",p"+in);
          //System.out.println("next_releasetime:"+next_arrivetime+",p"+live);
      
        }else{ 
          //客がいるとき、仕事にとりかかる
          System.out.println("#p"+ live +" workin "+sim_time);
          next_releasetime = sim_time + Passengers[live].getTasktime();
        }       
      }            
    }//loop
    
    //新規参入がないとわかった、単純な処理ですむ。ひたすら処理
    //ループに入る前の準備、すでにとりかかったタスクを消す
      waiting_time+=waiting_passenger*(next_releasetime - sim_time);
      sim_time=next_releasetime;
      System.out.println(sim_time+" "+waiting_passenger );
      waiting_passenger--;
      System.out.println(sim_time+" "+waiting_passenger );
      System.out.println("#p"+ live +" out "+sim_time+" "+waiting_passenger);
 
    while(live<pnum-1){
      live++;
      next_releasetime = sim_time + Passengers[live].getTasktime();    
      waiting_time+=waiting_passenger*(next_releasetime - sim_time);
      sim_time=next_releasetime;
      System.out.println(sim_time+" "+waiting_passenger );
      waiting_passenger--;
      System.out.println(sim_time+" "+waiting_passenger );
      System.out.println("#p"+ live +" out "+sim_time+" "+waiting_passenger );       
    }
    //結果を吐きだす.
    System.out.println("#simlating compelete!: "+sim_time);
    System.out.println("#avrage waiting time: "+ (waiting_time/pnum) );
    System.out.println("#total free time: "+free_time);
    System.out.println("#busy/free rate: "+(free_time/sim_time));
    
  } 
}
  